



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C++异常处理小例</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C++异常处理小例</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 14:55:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>&nbsp;</div>
<div>学习程序的好方法是阅读代码和改进代码。<br />下面的程例来自《An Overview of the C++ Programming Language》（5．1 异常和错误处理）<br />程序用途：使用C++的异常机制，报告stack的上溢或者下溢。（我适当的把代码补全。）</p>
<p>version 1 演示了基本的异常用法。<br />从try里抛出一个异常（实例或对象），由catch里的类接受。</p>
<div>&nbsp;1&nbsp;version&nbsp;1<br />&nbsp;2&nbsp;//&nbsp;From:&nbsp;An&nbsp;Overview&nbsp;of&nbsp;the&nbsp;C++&nbsp;Programming&nbsp;Language<br />&nbsp;3&nbsp;&nbsp;<br />&nbsp;4&nbsp;#include&nbsp;&lt;cstdlib&gt;<br />&nbsp;5&nbsp;#include&nbsp;&lt;iostream&gt;<br />&nbsp;6&nbsp;#include&nbsp;&lt;string&gt;<br />&nbsp;7&nbsp;using&nbsp;namespace&nbsp;std;<br />&nbsp;8&nbsp;<br />&nbsp;9&nbsp;template&lt;class&nbsp;T&gt;class&nbsp;Stack{<br />10&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;T*&nbsp;v;<br />11&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;int&nbsp;max_size;<br />12&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;int&nbsp;top;<br />13&nbsp;public:<br />14&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;class&nbsp;Underflow{&nbsp;};&nbsp;&nbsp;&nbsp;//&nbsp;下溢<br />15&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;class&nbsp;Overflow{&nbsp;};&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;上溢<br />16&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;construct&nbsp;function.&nbsp;determine&nbsp;the&nbsp;size&nbsp;&nbsp;&nbsp;<br />17&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Stack(int&nbsp;s):&nbsp;max_size(s),&nbsp;top(0){&nbsp;v&nbsp;=&nbsp;new&nbsp;T[max_size];}&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />18&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;~Stack(){}<br />19&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;void&nbsp;push(T&nbsp;c){<br />20&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if(top&nbsp;==&nbsp;max_size)&nbsp;throw&nbsp;Overflow();<br />21&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;v[top++]&nbsp;=&nbsp;c;<br />22&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />23&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;T&nbsp;pop(){<br />24&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if(top&nbsp;==&nbsp;0)&nbsp;throw&nbsp;Underflow();<br />25&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;v[--top];<br />26&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />27&nbsp;};&nbsp;<br />28&nbsp;<br />29&nbsp;void&nbsp;f()<br />30&nbsp;{<br />31&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Stack&lt;string&gt;&nbsp;ss(10);<br />32&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;try{<br />33&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ss.push("Quiz");<br />34&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;string&nbsp;s&nbsp;=&nbsp;ss.pop();<br />35&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ss.pop();<br />36&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />37&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;catch(Stack&lt;string&gt;::Overflow){<br />38&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cerr&nbsp;&lt;&lt;&nbsp;"error:&nbsp;stack&nbsp;overflow"&nbsp;&lt;&lt;&nbsp;endl;<br />39&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />40&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;catch(Stack&lt;string&gt;::Underflow){<br />41&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cerr&nbsp;&lt;&lt;&nbsp;"error:&nbsp;stack&nbsp;underflow"&nbsp;&lt;&lt;&nbsp;endl;<br />42&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />43&nbsp;}<br />44&nbsp;<br />45&nbsp;int&nbsp;main(int&nbsp;argc,&nbsp;char&nbsp;*argv[])<br />46&nbsp;{<br />47&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;f();<br />48&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;system("PAUSE");<br />49&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;EXIT_SUCCESS;<br />50&nbsp;}<br />51&nbsp;<br />52&nbsp;输出结果：error:&nbsp;stack&nbsp;underflow<br />53&nbsp;<br />54&nbsp;</div>
<p>改进，我们的第二个版本如下：<br />如果将</p>
<div>&nbsp;1&nbsp;&nbsp;class&nbsp;Underflow{&nbsp;};&nbsp;&nbsp;&nbsp;//&nbsp;下溢<br />&nbsp;2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;class&nbsp;Overflow{&nbsp;};&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;上溢<br />&nbsp;3&nbsp;和<br />&nbsp;4&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;catch(Stack&lt;string&gt;::Overflow){<br />&nbsp;5&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cerr&nbsp;&lt;&lt;&nbsp;"error:&nbsp;stack&nbsp;overflow"&nbsp;&lt;&lt;&nbsp;endl;<br />&nbsp;6&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;7&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;catch(Stack&lt;string&gt;::Underflow){<br />&nbsp;8&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cerr&nbsp;&lt;&lt;&nbsp;"error:&nbsp;stack&nbsp;underflow"&nbsp;&lt;&lt;&nbsp;endl;<br />&nbsp;9&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />10&nbsp;</div>
<p>分别改成如下：</p>
<div>&nbsp;1&nbsp;<br />&nbsp;2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;class&nbsp;Underflow{&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//<br />&nbsp;3&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;public:<br />&nbsp;4&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;void&nbsp;error(void){<br />&nbsp;5&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cerr&nbsp;&lt;&lt;&nbsp;"stack&nbsp;Underflow"&nbsp;&lt;&lt;&nbsp;endl;<br />&nbsp;6&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;&nbsp;&nbsp;&nbsp;<br />&nbsp;7&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;};&nbsp;&nbsp;&nbsp;<br />&nbsp;8&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;class&nbsp;Overflow{&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;<br />&nbsp;9&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;public:<br />10&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;void&nbsp;error(void){<br />11&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cerr&nbsp;&lt;&lt;&nbsp;"stack&nbsp;Overflow"&nbsp;&lt;&lt;&nbsp;endl;<br />12&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;<br />13&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;};&nbsp;&nbsp;&nbsp;<br />14&nbsp;和<br />15&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;catch(Stack&lt;string&gt;::Overflow&amp;&nbsp;e){<br />16&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;e.error();<br />17&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />18&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;catch(Stack&lt;string&gt;::Underflow&amp;&nbsp;e){<br />19&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;e.error();<br />20&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />21&nbsp;</div>
<p>改后的程序和原先的区别在哪里，看出来了吗？ 呵呵呵。</p>
<p>当然，我们还能将代码改进。这样产生了第三个版本。</p>
<p>第三个版本：version3<br />在Stack里面添加一个类class Stack_error,让Underflow和Overflow都继承它：</p>
<div>&nbsp;1&nbsp;template&lt;class&nbsp;T&gt;class&nbsp;Stack{<br />&nbsp;2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;<img referrerpolicy="no-referrer"src="http://www.cppblog.com/Images/dot.gif" />&nbsp;&nbsp;&nbsp;&nbsp;<br />&nbsp;3&nbsp;public:<br />&nbsp;4&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;class&nbsp;stack_error{<br />&nbsp;5&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;public:<br />&nbsp;6&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;virtual&nbsp;void&nbsp;error(void){　　//当然，可以把它做成纯虚的。抽象类。<br />&nbsp;7&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cerr&nbsp;&lt;&lt;&nbsp;"stack_error"&nbsp;&lt;&lt;&nbsp;endl;<br />&nbsp;8&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;9&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;};<br />10&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;class&nbsp;Underflow:&nbsp;public&nbsp;stack_error{&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//<br />11&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;public:<br />12&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;void&nbsp;error(void){<br />13&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cerr&nbsp;&lt;&lt;&nbsp;"stack&nbsp;Underflow"&nbsp;&lt;&lt;&nbsp;endl;<br />14&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;&nbsp;&nbsp;&nbsp;<br />15&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;};&nbsp;&nbsp;&nbsp;<br />16&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;class&nbsp;Overflow:&nbsp;public&nbsp;stack_error{&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;<br />17&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;public:<br />18&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;void&nbsp;error(void){<br />19&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cerr&nbsp;&lt;&lt;&nbsp;"stack&nbsp;Overflow"&nbsp;&lt;&lt;&nbsp;endl;<br />20&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;<br />21&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;};&nbsp;&nbsp;&nbsp;<br />22&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;<img referrerpolicy="no-referrer"src="http://www.cppblog.com/Images/dot.gif" /><br />23&nbsp;}<br />24&nbsp;</div>
<p>接着把两个catch合并成一个catch，如下。</p>
<div>&nbsp;&nbsp;try{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;the&nbsp;same<img referrerpolicy="no-referrer"src="http://www.cppblog.com/Images/dot.gif" /><br />&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;&nbsp;&nbsp;&nbsp;catch(Stack&lt;string&gt;::stack_error&amp;&nbsp;e){<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;e.error();<br />&nbsp;&nbsp;&nbsp;&nbsp;}</div>
<p>这三个版本的功能是一样的，但版本越高，代码越清晰，代码也越容易维护。</p>
<p>如果我们设计了一个库（比如上面的Stack），在开始的时候想到的就是两个异常，overflow和underflow。如果有version1和version3 这两种方法设计Stack，那么函数f()（用户的代码）也同样version1和version３。当一段日子过去了，我们准备再加入一个异常，比如midflow()（呵呵呵，我也想不出有什么类似的异常了）。这样的话，库设计者对用户说：&ldquo;我们发现了midflow()异常，并加入库代码中，请您改写您的代码f()。&rdquo;<br />这样我们的version1得修改成如下形式：</p>
<div>void&nbsp;f()<br />{<br />&nbsp;&nbsp;&nbsp;&nbsp;Stack&lt;string&gt;&nbsp;ss(10);<br />&nbsp;&nbsp;&nbsp;&nbsp;try{<br />　&nbsp;&nbsp;&nbsp;&nbsp;//<img referrerpolicy="no-referrer"src="http://www.cppblog.com/Images/dot.gif" />.<br />&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;&nbsp;&nbsp;&nbsp;catch(Stack&lt;string&gt;::Overflow){<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cerr&nbsp;&lt;&lt;&nbsp;"error:&nbsp;stack&nbsp;overflow"&nbsp;&lt;&lt;&nbsp;endl;<br />&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;&nbsp;&nbsp;&nbsp;catch(Stack&lt;string&gt;::Underflow){<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cerr&nbsp;&lt;&lt;&nbsp;"error:&nbsp;stack&nbsp;underflow"&nbsp;&lt;&lt;&nbsp;endl;<br />&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;&nbsp;&nbsp;&nbsp;catch(Stack&lt;string&gt;::Midflow){&nbsp;&nbsp;&nbsp;&nbsp;//我们的找到所有扑捉stack异常的代码，并加入这两句。<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cerr&nbsp;&lt;&lt;&nbsp;"error:&nbsp;stack&nbsp;midflow"&nbsp;&lt;&lt;&nbsp;endl;<br />&nbsp;&nbsp;&nbsp;&nbsp;}<br />}</div>
<p>而version3由于midflow()继承了stack_error。而其接口还是一样，客户代码就无需更改了。</p>
<p>完毕。鞠躬。 请多多交流！</p>
<p>附：version3完整代码：</p>
<div>&nbsp;1&nbsp;Version&nbsp;3:<br />&nbsp;2&nbsp;#include&nbsp;&lt;cstdlib&gt;<br />&nbsp;3&nbsp;#include&nbsp;&lt;iostream&gt;<br />&nbsp;4&nbsp;<br />&nbsp;5&nbsp;using&nbsp;namespace&nbsp;std;<br />&nbsp;6&nbsp;<br />&nbsp;7&nbsp;template&lt;class&nbsp;T&gt;class&nbsp;Stack{<br />&nbsp;8&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;T*&nbsp;v;<br />&nbsp;9&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;int&nbsp;max_size;<br />10&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;int&nbsp;top;<br />11&nbsp;public:<br />12&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;class&nbsp;stack_error{<br />13&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;public:<br />14&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;virtual&nbsp;void&nbsp;error(void)&nbsp;=&nbsp;0;<br />15&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;};<br />16&nbsp;<br />17&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;class&nbsp;Underflow:&nbsp;public&nbsp;stack_error{&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//<br />18&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;public:<br />19&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;void&nbsp;error(void){<br />20&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cerr&nbsp;&lt;&lt;&nbsp;"stack&nbsp;Underflow"&nbsp;&lt;&lt;&nbsp;endl;<br />21&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;&nbsp;&nbsp;&nbsp;<br />22&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;};&nbsp;&nbsp;&nbsp;<br />23&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;class&nbsp;Overflow:&nbsp;public&nbsp;stack_error{&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;<br />24&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;public:<br />25&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;void&nbsp;error(void){<br />26&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cerr&nbsp;&lt;&lt;&nbsp;"stack&nbsp;Overflow"&nbsp;&lt;&lt;&nbsp;endl;<br />27&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;<br />28&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;};&nbsp;&nbsp;&nbsp;<br />29&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Stack(int&nbsp;s):&nbsp;max_size(s),&nbsp;top(0){&nbsp;v&nbsp;=&nbsp;new&nbsp;T[max_size];}&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;construct&nbsp;function.&nbsp;determine&nbsp;the&nbsp;size&nbsp;&nbsp;&nbsp;<br />30&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;~Stack(){}<br />31&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;void&nbsp;push(T&nbsp;c){<br />32&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if(top&nbsp;==&nbsp;max_size)&nbsp;throw&nbsp;Overflow();<br />33&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;v[top++]&nbsp;=&nbsp;c;<br />34&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />35&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;T&nbsp;pop(){<br />36&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if(top&nbsp;==&nbsp;0)&nbsp;throw&nbsp;Underflow();<br />37&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;v[--top];<br />38&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />39&nbsp;};&nbsp;<br />40&nbsp;<br />41&nbsp;void&nbsp;f()<br />42&nbsp;{<br />43&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Stack&lt;string&gt;&nbsp;ss(0);<br />44&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;try{<br />45&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ss.push("Quiz");<br />46&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;string&nbsp;s&nbsp;=&nbsp;ss.pop();<br />47&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ss.pop();<br />48&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />49&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;catch(Stack&lt;string&gt;::stack_error&amp;&nbsp;e){<br />50&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;e.error();<br />51&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />52&nbsp;<br />53&nbsp;}<br />54&nbsp;<br />55&nbsp;int&nbsp;main(int&nbsp;argc,&nbsp;char&nbsp;*argv[])<br />56&nbsp;{<br />57&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;f();<br />58&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;system("PAUSE");<br />59&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;EXIT_SUCCESS;<br />60&nbsp;}</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qyz0zg9.html">&lbrack; html canvas putImageData &rsqb; canvas绘图属性 putImageData 属性讲解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydgzzxq.html">android广播集合，intent，action</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydl5e2q.html">javascript 单行向上滚动文字</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z6o259.html">iPad横竖屏代码适配</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdvjwe8.html">java中的io系统详解&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zg7jz9.html">solr6环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjgjzx8.html">Java入门（4）&mdash;&mdash;常见的String方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1l7wmq.html">【CJOJ1372】【洛谷2730】【USACO 3&period;2&period;5】魔板</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjmxxy8.html">java安装及设置环境变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pry248.html">javascript深入浅出图解作用域链和闭包</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojmrlxq.html">JUC笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj7vk38.html">&lbrack;CF542D&rsqb;Superhero&amp;&num;39&semi;s Job</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o115n1q.html">&lbrack;转&rsqb; KVM storage performance and cache settings on Red Hat Enterprise Linux 6&period;2</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyew4v9.html">Android热修复&mdash;&mdash;Tinker的集成</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5pjgdq.html">Java知多少（55）线程</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g2nnmq.html">Python&colon; 如何写一个异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllyreeq.html">iOS图片按比例显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rgwv58.html">如何让win2008服务器显示中文无乱码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9630l0y9.html">MYSQL 5&period;5&period;32的单机多实例部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2l4mv8.html">zabbix-proxy配置</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxnv2jv8.html">Android studio  开发中 用git实现批量忽略特定文件的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xzper9.html">cf581A Vasya the Hipster</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k17mn79.html">HDU&lowbar;2054&mdash;&mdash;A&equals;B问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xzjer9.html">UVA 11636 - Hello World&excl; 水</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xzj5r9.html">关于本学期西南交通大学ACM-ICPC校集训队 训练计划（Beta 1&period;0）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdx0gd8.html">SqlServer 挂载本地盘符到服务器端，方面备份还原</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1o50x8.html">yii 使用 phpmailer发送邮件</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j03prwq.html">PHP中字符串类型与数值类型混合计算</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okegg19.html">Server Job&colon; error&colon; String or binary data would be truncated&period; The statement has been terminated&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm4k269.html">【Python爬虫基础】抓取知乎页面所有图片</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
